-------------------------------------------------------------------------------
-- MrTrader
--
-- Suite of tools for the avid crafter.
--
-- Send suggestions, comments, and bugs to user@zedonline.net
-------------------------------------------------------------------------------

-- Singleton (With AceHook embedded)
MRTHooks = LibStub("AceHook-3.0");

function MRTHooks:OnEnable()
	self:RawHook("TradeSkillFrame_LoadUI", nil, true);
end

function MRTHooks:OnDisable()
	self:Unhook("TradeSkillFrame_LoadUI");
	if( self.hooks["TradeSkillFrame_Show"] ) then
		self:Unhook("TradeSkillFrame_Show");
	end
end

function MRTHooks_TradeSkillFrame_Show()
	-- OnDemand load the appropriate moddule and show it.
	-- If MrTrader_SkillWindow cannot be loaded, or has been disabled, go with the default of the original.
	if( MrTrader:ShouldUseCustomWindow() and LoadAddOn("MrTrader_SkillWindow") ) then
		-- Load and Call
		MRTSkillWindow:Show();
	else
		-- Load, Hook, and Call Original
		MRTHooks.hooks["TradeSkillFrame_LoadUI"]();
		if( MRTHooks.hooks["TradeSkillFrame_Show"] == nil ) then
			MRTHooks:RawHook("TradeSkillFrame_Show", MRTHooks_TradeSkillFrame_Show, true);	
		end
		MRTHooks.hooks["TradeSkillFrame_Show"]();
	end
end

function MRTHooks:TradeSkillFrame_LoadUI()
	-- Put ourselves in as the function for TradeSkillFrame_Show, as a pre-loaded hook.
	TradeSkillFrame_Show = MRTHooks_TradeSkillFrame_Show;
end